;Address.cl

; either username or username@sitename is considered an ADDRESS

(define-primitive ADDRESS CLASSIC-THING)

    (define-concept USERNAME
	(and IDENTIFIER
	    (test-c username? name))
    )

    (define-concept EMAIL-ADDRESS
	(and IDENTIFIER
	    (test-c email? name))
    )

    (define-rule rule-address1 USERNAME ADDRESS)
    (define-rule rule-address2 EMAIL-ADDRESS ADDRESS)

; The reason that ADDRESS is defined as a primitive concept and asserted
; as a rule consequence in USERNAME and EMAIL-ADDRESS, compared to another
; design where both USERNAME and EMAIL-ADDRESS descend from ADDRESS is
; because of efficiency.  In the latter design, it is necessary to put a 
; test-c in ADDRESS to test whether an IDENTIFIER satisfies either 
; "username?" or "email?".  Then this has to be done again in USERNAME
; and ADDRESS.

; There is also another kind of address that is the recipient of an xsend
; operation.

    (define-primitive ENROLLED-ADDRESS ADDRESS)
