; Command.cl

; Command Categories

(define-primitive INTERACTION CLASSIC-THING)
    (define-primitive INTERACTIVE INTERACTION)
    (define-primitive FORCE INTERACTION)

(define-primitive NETWORK CLASSIC-THING)
    (define-primitive TRANSFER NETWORK)

(define-primitive FILE-MANIPULATION CLASSIC-THING)
    (define-primitive RECURSIVE FILE-MANIPULATION)
    (define-primitive CREATION FILE-MANIPULATION)
    (define-primitive DESTRUCTIVE FILE-MANIPULATION)
	(define-primitive DELETION DESTRUCTIVE)
	(define-primitive REPLACEMENT DESTRUCTIVE)
    (define-primitive COPY FILE-MANIPULATION)
    (define-primitive MOVE FILE-MANIPULATION)
	(define-primitive RENAME MOVE)
    (define-primitive INSPECT FILE-MANIPULATION)

(define-primitive REVERSIBLE CLASSIC-THING)
(define-concept INTERACTIVE-DESTRUCTIVE (and INTERACTIVE DESTRUCTIVE))
(define-concept FORCED-DESTRUCTIVE (and FORCE DESTRUCTIVE))

(define-role arguments)
(define-role options)
(define-role optargs)

(define-attribute first-argument)
(define-attribute last-argument)
(define-attribute input)
(define-attribute output)
(define-attribute optstr)

;------------------------------------------------------------------

; Definition of a command

(define-primitive COMMAND 
    (and (all name STRING)
	(exactly 1 name)
	(all arguments IDENTIFIER)
	(all options STRING)
	(all optargs STRING)
	(all optstr STRING)))

; This is the concept for simple commands (w/o arguments), eg ls, du...

    (define-concept COMMAND-PLAIN 
	(and COMMAND 
	    (exactly 0 arguments)))

; This is the concept for commands that require arguments.

    (define-concept COMMAND-AUGMENTED
	(and COMMAND 
	    (at-least 1 arguments)))

(define-rule rule-first-argument
    COMMAND-AUGMENTED 
    (computed-filler find-first-argument first-argument arguments))

(define-rule rule-last-argument
     COMMAND-AUGMENTED 
     (computed-filler find-last-argument last-argument arguments))

; Should be filled in by parser.  Further, even commands like cp
; should have stdin and stdout.  It's just that the program cp
; doesn't make use of it.
;
; This is a command that has the keyboard as default input
;(define-primitive COMMAND-DEFAULT-INPUT COMMAND)
;
;(define-rule rule-default-input
;     COMMAND-DEFAULT-INPUT
;     (computed-filler default-fillers input keyboard))
;
; This is a command that has the screen as default output
;(define-primitive COMMAND-DEFAULT-OUTPUT COMMAND)
;
;(define-rule rule-default-output
;     COMMAND-DEFAULT-OUTPUT
;     (computed-filler default-fillers output screen))
;
; The conjunction of the above is a command that has both stdin and stdout.
;(define-concept COMMAND-DEFAULT-IO
;     (and COMMAND-DEFAULT-INPUT COMMAND-DEFAULT-OUTPUT))
