; Date.cl

(define-attribute year)
(define-attribute month)
(define-attribute day)
(define-attribute dow)

; DATE is a primitive concept under CLASSIC-THING that is an abstraction
; of a date.  It has the following roles:
;
;    year: an integer indicating the year
;    month: an integer indicating the month
;    day: an integer indicating the day
;    dow: an integer indicating the day of week, 0 = Sunday
;    
; A procedural test "legal-date?" checks the validity for each DATE
; individual.

(define-primitive DATE 
    (and (all year INTEGER)
	(all month INTEGER)
	(all day INTEGER)
	(all dow INTEGER)
	(test-c legal-date? year month day)))

; This rule fires for each DATE individual to find out the day of week
; when year/month/day are specified.
 
(define-rule rule-dow DATE (computed-fillers find-dow dow year month day))
