; File.cl

(define-attribute st_dev)
(define-attribute st_ino) 
(define-attribute st_mode) 
(define-attribute st_nlink)
(define-attribute st_uid) 
(define-attribute st_gid) 
(define-attribute st_rdev)
(define-attribute st_size) 
(define-attribute st_atime)
(define-attribute st_mtime)
(define-attribute st_ctime)
(define-attribute st_blksize)
(define-attribute st_blocks)

; FILE is the most important concept in UNIX.  The following attributes 
; of FILE are taken out of the "stat" man-page.  "stat" is a command 
; that retrieves attributes of a UNIX file.
;
; There are two ways of defining a FILE individual.  Logically speaking,
; a FILE individual should be defined by 
;
;   (and FILE (fills st-dev ...) (fills st_ino ...) ...)
;
; This is tedious.  A more realistic way is to define a PATHNAME ind and
; let EXISTENCE take care of the filling.

(define-primitive FILE  
   (and
       (all st_dev INTEGER)
       (all st_ino INTEGER) 
       (all st_mode INTEGER) 
       (all st_nlink INTEGER)
       (all st_uid INTEGER) 
       (all st_gid INTEGER) 
       (all st_rdev INTEGER)
       (all st_size INTEGER) 
       (all st_atime INTEGER)
       (all st_mtime INTEGER)
       (all st_ctime INTEGER)
       (all st_blksize INTEGER)
       (all st_blocks INTEGER)))

; A file mode is associated with each file

(define-rule rule-file-mode
    FILE 
    (computed-filler file-mode mode st_mode))

; A file type is associated with each file

(define-rule rule-file-type
    FILE 
    (computed-concept file-type fname))

