; Filename.cl

; A FILENAME is an IDENTIFIER.  It must fulfill the requirements in the
; procedural test "filename?", which is OS dependent.  

(define-concept FILENAME 
    (and IDENTIFIER 
	(test-c filename? name)))

; In UNIX, a HIDDEN-FILENAME is one that has a '.' character as its 
; prefix.

(define-concept HIDDEN-FILENAME 
    (and FILENAME 
	(test-c strprefix name ".")))

; Since a FILENAME and a RELNAME is a relative name, we need to find
; out the directory that this name is issued.

(define-rule rule-filename-cwd
    FILENAME
    (computed-filler getcwd cwd))

