; Fname.cl

(define-role fname)
(define-attribute base)
(define-attribute suffix)
(define-attribute realpath)

; FNAME is a primitive concept used to abstract the three main
; kinds of filenames, namely FILENAME, RELNAME and PATHNAME

(define-primitive FNAME CLASSIC-THING)

(define-rule rule-pathname-fname 
    PATHNAME
    FNAME)

(define-rule rule-filename-fname
    FILENAME
    FNAME)

(define-rule rule-relname-fname
    RELNAME
    FNAME)

; There are some properties of FNAME that we need to define.

; Extract suffix and base name

(define-rule rule-fname-suffix
    FNAME
    (computed-fillers filename-suffix suffix name))

(define-rule rule-fname-base
    FNAME
    (computed-fillers filename-base base name))

; Find the canonical pathname representation

(define-rule rule-fname-realpath
    FNAME
    (computed-fillers fname-realpath realpath name))

; A type is associated with each Fname

(define-rule rule-fname-type
    FNAME
    (computed-concept filename-type name suffix))

; Test for EXISTENCE

(define-rule rule-fname-existence
    FNAME
    EXISTENCE)

