; Static.cl

;
; The convention I used has all upper case for concepts.  So, I am
; defining macros for the built-ins.
;
(define-concept STRING string)
(define-concept INTEGER integer)
(define-concept FLOAT float)
(define-concept NUMBER number)
(define-concept THING thing)
(define-concept CLASSIC-THING classic-thing)
(define-concept HOST-THING host-thing)

(load "Date.cl")
(load "Mode.cl")
(load "Type.cl")
(load "Identifier.cl")
    (load "Filename.cl")
    (load "Relname.cl")
    (load "Pathname.cl")
(load "Existence.cl")
(load "Fname.cl")
    (load "Name.cl")
(load "File.cl")

(load "Address.cl")

; in UNIX, the keyboard is considered as a text file when used as
; I/O redirection.

(define-ind keyboard (and FILE TEXT READ-ONLY1 (fills name "keyboard")))
(define-ind screen (and FILE TEXT (fills name "screen")))

(load "Command.cl")
    (load "cat.cl")
    (load "cp.cl")
    (load "compress.cl")
    (load "crypt.cl")
    (load "mail.cl")
    (load "mv.cl")
    (load "rm.cl")
    (load "uncompress.cl")
    (load "uudecode.cl")
    (load "uuencode.cl")
    (load "xsend.cl")


;(load "zzz.cl")
