; compress.cl

(define-concept COMPRESS
    (and COMMAND 
	(fills name "compress")))
(define-rule rule-compress1 COMPRESS (fills optstr "-cfvb:"))

    (define-concept COMPRESS-SYNTAX
	(and COMPRESS 
	    (all options (one-of "-c" "-f" "-v" "-b"))))
    (define-rule rule-compress-output COMPRESS-SYNTAX (all output COMPRESSED))
    (define-rule rule-compress2 COMPRESS-SYNTAX REVERSIBLE)

; compress -f ...

    (define-concept COMPRESS-OPTION-FORCE
	(and COMPRESS 
	    (fills options "-f")))
    (define-rule rule-compress3 COMPRESS-OPTION-FORCE FORCE)


; compress -b bits ...

    (define-attr compress-bits)
    (define-concept COMPRESS-OPTION-BITS
	(and COMPRESS 
	    (fills options "-b")))
     
    (define-rule rule-compress-bits
	 COMPRESS-OPTION-BITS
	 (computed-filler get-option-integer compress-bits "-b"))

; compress filename ...

    (define-concept COMPRESS-FILE
	(and COMPRESS-SYNTAX
	    (at-least 1 arguments)
	    (all arguments NAME-of-EXIST-FILE)))

; COMPRESS-FILE is DESTRUCTIVE unless -c is supplied.

	(define-concept COMPRESS-DESTRUCTIVE
	    (and COMPRESS-FILE
		(all options (one-of "-f" "-v" "-b"))))
	(define-rule rule-compress-destructive COMPRESS-DESTRUCTIVE DESTRUCTIVE)
	       
; compress < filename

    (define-concept COMPRESS-STDIN
	(and COMPRESS-SYNTAX
	    (exactly 0 arguments)))
