; cp.cl

(define-concept CP 
    (and COMMAND 
	(fills name "cp")))
(define-rule rule-cp1 CP (fills optstr "iprR"))
(define-rule rule-cp2 CP COPY)

    (define-concept CP-SYNTAX
	(and CP
	    (at-least 2 arguments)
	    (all options (one-of "-i" "-p" "-r" "-R"))))

; cp -i ...

    (define-concept CP-OPTION-INTERACTIVE
	(and CP 
	    (fills options "-i")))

    (define-rule rule-cp-interactive CP-OPTION-INTERACTIVE INTERACTIVE)

; cp -r ...

    (define-concept CP-OPTION-RECURSIVE1
        (and CP 
	    (fills options "-r")))

; cp -R ...

    (define-concept CP-OPTION-RECURSIVE2
        (and CP 
	    (fills options "-R")))

    (define-rule rule-cp-recursive1 CP-OPTION-RECURSIVE1 RECURSIVE)
    (define-rule rule-cp-recursive2 CP-OPTION-RECURSIVE2 RECURSIVE)

; cp old_file new_file

	(define-concept CP-PLAIN
	    (and CP-SYNTAX
		(exactly 2 arguments)
		(all first-argument NAME-of-EXIST-NORMAL-FILE)
		(all last-argument NAME-of-NON-EXIST-FILE)))

; cp old_file1 old_file2

	(define-concept CP-DESTRUCTIVE
	    (and CP-SYNTAX
		(exactly 2 arguments)
		(all arguments NAME-of-EXIST-NORMAL-FILE)))

; cp -rR old_dir new_dir

	(define-concept CP-DIRECTORY1
	    (and CP-SYNTAX
		RECURSIVE
		(exactly 2 arguments)
		(all first-argument NAME-of-EXIST-DIRECTORY)
		(all last-argument NAME-of-NON-EXIST-FILE)))

; cp -rR old_dir1 old_dir2

	(define-concept CP-DIRECTORY2
	    (and CP-SYNTAX
		RECURSIVE
		(exactly 2 arguments)
		(all first-argument NAME-of-EXIST-DIRECTORY)
		(all last-argument NAME-of-EXIST-DIRECTORY)))

; cp old_file1 old_file2 ... old_dir

	(define-concept CP-GROUP
	    (and CP-SYNTAX
		(all arguments NAME-of-EXIST-FILE)
		(all last-argument NAME-of-EXIST-DIRECTORY)
		(test-c some arguments NAME-of-EXIST-DIRECTORY 1 1)))

; cp -rR old_file1 old_file2 some_dir... old_dir

	(define-concept CP-GENERAL
	    (and CP-SYNTAX
		RECURSIVE
		(at-least 3 arguments)
		(all arguments NAME-of-EXIST-FILE)
		(all last-argument NAME-of-EXIST-DIRECTORY)
		(test-c some arguments NAME-of-EXIST-DIRECTORY 2)))

; There are two kinds of copying, one is CREATION (when the target
; file does not exist), the other is REPLACEMENT (when the target
; file exists).  We need to assert that.

    (define-concept CP-CREATION
	(and COPY
	    (all last-argument NAME-of-NON-EXIST-FILE)))

    (define-rule rule-cp-creation CP-CREATION CREATION)

    (define-concept CP-REPLACEMENT
	(and COPY
	    (all last-argument NAME-of-EXIST-NORMAL-FILE)))

    (define-rule rule-cp-replacement CP-REPLACEMENT REPLACEMENT)

; It is more complicated when the last-argument is NAME-of-EXIST-
; DIRECTORY.  Whether this is a CREATION or a REPLACEMENT (or both)
; depends on the files within that directory.  Since there is no 
; way to tell from the command line, this knowledge cannot be 
; encoded at the syntactic level.
