; crypt.cl

(define-concept CRYPT
    (and COMMAND 
	(fills name "crypt")))

    (define-concept CRYPT-SYNTAX
	(and CRYPT
	    (between 0 1 arguments)
	    (exactly 0 options)))

    (define-rule rule-crypt-reversible CRYPT-SYNTAX REVERSIBLE)

; crypt password < infile > outfile

	(define-concept CRYPT-PASSWORD
	    (and CRYPT-SYNTAX
		(exactly 1 arguments)))

; crypt < infile > outfile

	(define-concept CRYPT-PLAIN
	    (and CRYPT-SYNTAX 
		(exactly 0 arguments)))

; Both encoding and decoding is done by the same command "crypt".
; To tell the difference, we need perfect file type mechanisms.
; Assuming that, when input is ENCRYPTED, the "crypt" command is
; decoding; otherwise, encoding.

; input is ENCRYPTED

	(define-concept CRYPT-DECODE
	    (and CRYPT-SYNTAX
		(all input ENCRYPTED)))

; input is not ENCRYPTED

	(define-concept CRYPT-ENCODE
	    (and CRYPT-SYNTAX
		(test-c some input ENCRYPTED 0 0)))

	; output is ENCRYPTED in this case
	(define-rule rule-crypt-encode CRYPT-ENCODE (all output ENCRYPTED))	

