; mail.cl

(define-attribute mail-subject)

; This represents only the sendmail property of UCB mail.  There are
; other properties such as displaying mails, deleting mails from the
; mailbox etc. that we have ignored.  It is probably more appropriate
; to use the UNIX "sendmail" command as a model.  "mail" is used simply
; because "sendmail" is almost never used due to "mail" duplicating it.

(define-concept MAIL
    (and COMMAND 
	(fills name "mail")))

(define-rule rule-mail1 MAIL (fills optstr "vins:"))
(define-rule rule-mail2 MAIL TRANSFER)

    (define-concept MAIL-SYNTAX
	(and MAIL 
	    (at-least 1 arguments)
	    (all options (one-of "-v" "-i" "-n" "-s"))))

	(define-concept MAIL-PLAIN
	    (and MAIL-SYNTAX
		(all arguments ADDRESS)
		(exactly 1 input)
		(all input TEXT)))

    (define-concept MAIL-OPTION-SUBJECT
	(and MAIL 
	    (fills options "-s")))

    (define-rule rule-mail-subject
	MAIL-OPTION-SUBJECT
	(computed-filler get-option mail-subject "-s"))
