; mv.cl

(define-concept MV
    (and COMMAND 
	(fills name "mv")))

(define-rule rule-mv1 MV (fills optstr "fi"))
(define-rule rule-mv2 MV MOVE)

    (define-concept MV-SYNTAX
	(and MV
	    (at-least 2 arguments)
	    (all options (one-of "-f" "-i"))))

; mv -i

    (define-concept MV-OPTION-INTERACTIVE
	(and MV 
	    (fills options "-i")))
    (define-rule rule-mv-interactive MV-OPTION-INTERACTIVE INTERACTIVE)

; mv -f
    (define-concept MV-OPTION-FORCE
	(and MV 
	    (fills options "-f")))
    (define-rule rule-mv-force MV-OPTION-FORCE FORCE)

; mv old_file new_file
; mv old_dir new_dir
; ... same as rename

	(define-concept MV-RENAME
	    (and MV-SYNTAX
		(exactly 2 arguments)
		(all first-argument NAME-of-EXIST-FILE)
		(all last-argument NAME-of-NON-EXIST-FILE)))
	(define-rule rule-mv-rename MV-RENAME RENAME)

; mv old_file1 old_file2

	(define-concept MV-DESTRUCTIVE
	    (and MV-SYNTAX
		(exactly 2 arguments)
		(all arguments NAME-of-EXIST-NORMAL-FILE)))

; mv old_file old_dir2 ... old_dir2

	(define-concept MV-GENERAL
	    (and MV-SYNTAX
		(all arguments NAME-of-EXIST-FILE)
		(all last-argument NAME-of-EXIST-DIRECTORY)))

; There are two kinds of moving, one is CREATION (when the target
; file does not exist), the other is REPLACEMENT (when the target
; file exists).  We need to assert that.

    (define-concept MV-CREATION
	(and MV
	    (all last-argument NAME-of-NON-EXIST-FILE)))

    (define-rule rule-mv-creation MV-CREATION CREATION)

    (define-concept MV-REPLACEMENT
	(and MV
	    (all last-argument NAME-of-EXIST-NORMAL-FILE)))
    
    (define-rule rule-mv-replacement MV-REPLACEMENT REPLACEMENT)

; It is more complicated when the last-argument is NAME-of-EXIST-
; DIRECTORY.  Whether this is a CREATION or a REPLACEMENT (or both)
; depends on the files within that directory.  Since there is no 
; way to tell from the command line, this knowledge cannot be 
; encoded at the syntactic level.
